// 6.05.2007   
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//|                                               BrainTrend1Sig.mq4 |
//|                                     BrainTrading Inc. System 7.0 |
//|                                      http://www.braintrading.com |
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
#property copyright "BrainTrading Inc. System 7.0"
#property link      "http://www.braintrading.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Magenta
#property indicator_color2 Aqua
//---- input parameters
extern int       EnableAlerts=0;
extern int       SignalID=0;
extern int       CountBars=500;
extern int    Price          = 0;    //Price mode : 0-Close,1-Open,2-High,3-Low,4-Median,5-Typical,6-Weighted
extern int    Order          = 3;    //Filter Order: 1-1st,2-2nd,3-3rd,4-4th
extern int    FilterPeriod   = 10;    //Filter Period 
extern int    PreSmooth      = 1;    //Pre-smoothing period
extern int    PreSmoothMode  = 0;    //Pre-smoothing MA Mode: 0-SMA,1-EMA,2-SMMA,3-LWMA
extern double PctFilter      = 0.0;  //Dynamic filter in decimal(multiplier for StdDev)



//---- buffers
double Ind_Buffer1[];
double Ind_Buffer2[];
//---- 
int    shift,limit,f,p,x1,x2,value11,a1,tsig;
double value2,value3,Range,Range1,Range2,val1,val2,d,val3,s;
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//| Custom indicator initialization function                         |
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
int init()
  {
//---- indicator 0
   SetIndexStyle (0,DRAW_ARROW);
   SetIndexArrow (0,108);
   SetIndexBuffer(0,Ind_Buffer1);
   SetIndexEmptyValue(0,0.0);
//---- indicator 1  
   SetIndexStyle (1,DRAW_ARROW);
   SetIndexArrow (1,108);
   SetIndexBuffer(1,Ind_Buffer2);
   SetIndexEmptyValue(1,0.0);
//----
   string short_name;
   short_name="BrainTrend1Sig";
   IndicatorShortName(short_name);
   SetIndexLabel(0,""+short_name+"_SELL");
   SetIndexLabel(1,""+short_name+"_BUY" );
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- 
   f=7; d=2.3; x1 = 53; x2 = 47; value11 = 9; s=1.5;
//----
   return(0);
  }
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//| Custom indicator iteration function                              |
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
int start()
  {
   double CloseVal, CloseVal2, HighVal, LowVal;
   int    counted_bars=IndicatorCounted();
   if (Bars < 11)return(0);
   if (CountBars > Bars-1-11)CountBars=Bars-1-11;
//----  
   limit = CountBars;//-counted_bars-1 
//----  
   shift=limit;
   p=0;
//---- 
while(shift>=0)

      {
      Range = iATR(NULL,0,f,shift);
      Range1 = Range / d;
      Range2 = Range * s / 4;
      value2 = iStochastic(NULL,0,value11,value11,1,0,0,0,shift);
      
      CloseVal  = NormalizeDouble(iCustom(Symbol(),Period(),"GaussianFilter_v1",Price,Order,FilterPeriod,PreSmooth,PreSmoothMode,PctFilter,shift),Digits);
      CloseVal2 = NormalizeDouble(iCustom(Symbol(),Period(),"GaussianFilter_v1",Price,Order,FilterPeriod,PreSmooth,PreSmoothMode,PctFilter,shift + 2),Digits);
      HighVal = NormalizeDouble(iCustom(Symbol(),Period(),"GaussianFilter_v1",2,Order,FilterPeriod,PreSmooth,PreSmoothMode,PctFilter,shift),Digits);
      LowVal  = NormalizeDouble(iCustom(Symbol(),Period(),"GaussianFilter_v1",3,Order,FilterPeriod,PreSmooth,PreSmoothMode,PctFilter,shift),Digits);
      
      val1 = 0;
      val2 = 0;
      val3 = MathAbs(CloseVal - CloseVal2);
      if (value2 < x2 && val3 > Range1&&(p == 2 || p == 0)) 
            {
            value3 = HighVal + Range2;
            val1 = value3;
            p = 1;
            }       
      if (value2 > x1 && val3 > Range1&&(p == 1 || p == 0)) 
            {
            value3 = LowVal - Range2;
            val2 = value3;
            p = 2;
            }
      Ind_Buffer1[shift]=val1;
      Ind_Buffer2[shift]=val2;  
    
       shift--;
      }
if (EnableAlerts == 1 && val1 > 0 && tsig != 1) 
      {
      tsig = 1;
      a1 = FileOpen("alert1" + SignalID,";");
      FileWrite(a1,"Sell ", Symbol(), " at ", Close[0], " S/L ", val1, " BT1 M", Period());
      FileClose(a1);
      }
if (EnableAlerts == 1 && val1 > 0 && tsig != 2) 
      {
      tsig = 2;
      a1 = FileOpen("alert1" + SignalID,";");
      FileWrite(a1,"Buy ",  Symbol(), " at ", Close[0]," S/L ", val2, " BT1 M",  Period());
      FileClose(a1);
      }
//----
   return(0);
  }
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+